//wrapper to run sudo.sh, see /usr/sbin/bootmanager example.
//sudo-sh must be root:root 4711 (setuid). sudo.sh root:root 0700
//20231219 v1.3 fix seg fault if DISPLAY not defined.
//20250329 v1.4 wait for other sudo-sh finished.
//20250330 v1.5 handle more than 7 params.
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
int main(int argc, char *argv[], char *envp[]) {
 
 char outmsg[512];
 outmsg[0]=0;
 int thispid = getpid();
 char pidstr[12];
 pidstr[0]=0;
 sprintf(pidstr, "%d", thispid);

 //the idea is that if sudo-sh setuid has been ignored (ex: electron app)
 //then write the params to sudosh_pass file, which will be read by /root/Startup/sudo-sh-ipc
 //which will call /usr/bin/sudo-sh as root, with the params.
 int euid = geteuid();
 if (euid != 0) {
  char ipcfile[] = "/tmp/pup_event_ipc/sudosh_pass";
  int x;
  //argv[0] is name of this prog, ignore that...
  for (x=1; x<argc; x++) {
   strcat(outmsg,argv[x]);
   strcat(outmsg," ");
  }
  int ipcdescr = open(ipcfile, O_WRONLY|O_APPEND); //|O_CREAT
  if (ipcdescr != 0) {
   int wr1 = write(ipcdescr,outmsg,strlen(outmsg));
   close(ipcdescr);
  }
  
  outmsg[0]=0;
  strcat(outmsg,"/usr/local/clients/wait-other-sudo-sh ");
  strcat(outmsg,pidstr);
  
  //write pid to a file also...
  char nonrootpidfile[] = "/tmp/sudo-sh-pid-nonroot";
  int nonrootpiddescr = open(nonrootpidfile, O_WRONLY|O_APPEND|O_CREAT, 0644); 
  if (nonrootpiddescr != 0) {
   int wr2 = write(nonrootpiddescr,pidstr,strlen(pidstr));
   close(nonrootpiddescr);
  }
  
  //wait for ack from /root/Startup/sudo-sh-ipc...
  system("inotifywait -q -q -t 2 -e modify /tmp/pup_event_ipc/sudosh_ack");
  //wait until other root sudo-sh has finished...
  system(outmsg);
  exit(0);
 }
 setuid(0);
 //execv("/usr/bin/sudo.sh",argv);
 //the above works, but maybe, very maybe, a security weakness:
 // https://unix.stackexchange.com/questions/364/allow-setuid-on-shell-scripts
 //so do it this way, run the ash interpreter here...
 //also, don't pass envp...
 
 //write pid to a file...
 char rootpidfile[] = "/tmp/sudo-sh-pid-root";
 int rootpiddescr = open(rootpidfile, O_WRONLY|O_APPEND|O_CREAT, 0644); 
 if (rootpiddescr != 0) {
  int wr3 = write(rootpiddescr,pidstr,strlen(pidstr));
  close(rootpiddescr);
 }

 extern char **environ;
 char *lang;
 lang=getenv("LANG");
 char langenv[] = "LANG=";
 //20231219 add test that variable defined...
 if (lang != NULL) strcat(langenv,lang);
 char *display;
 display=getenv("DISPLAY");
 char displayenv[] = "DISPLAY=";
 //20231219 add test that variable defined...
 if (display != NULL) strcat(displayenv,display);
 
 char *envp2[] = { displayenv,
  "XDG_CACHE_HOME=/root/.cache",
  "XDG_CONFIG_DIRS=/etc/xdg",
  "XDG_CONFIG_HOME=/root/.config",
  "XDG_DATA_DIRS=/usr/share:/usr/local/share",
  "XDG_DATA_HOME=/root/.local/share",
  "XLIB_SKIP_ARGB_VISUALS=1",
  "QT5DIR=/usr",
  "QT_QPA_PLATFORMTHEME=gtk2",
  "QT_XFT=true",
  "RGBDEF=/usr/share/X11/rgb.txt",
  "SHELL=/bin/bash",
  "PULSE_RUNTIME_PATH=/run/pulse",
  "PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin",
  "OSTYPE=linux-gnu",
  "MOZILLA_FIVE_HOME=/usr/lib/seamonkey",
  "MOZ_DISABLE_PANGO=1",
  "MOZ_PLUGIN_PATH=/usr/lib/mozilla/plugins",
  "NO_AT_BRIDGE=1",
  "OOO_FORCE_DESKTOP=gnome",
  "LS_COLORS=bd=33:cd=33",
  "LIBASOUND_THREAD_SAFE=0",
  "INPUTRC=/etc/inputrc",
  "GTK2_RC_FILES=/root/.gtkrc-2.0",
  "G_FILENAME_ENCODING=@locale",
  langenv,
 NULL};

 //i don't know C well enough to do this for an arbitrary # of params...
 //note, argv[0] has name of this script. argv[1] has pid of caller-of-caller
 char binash[] = "/bin/ash";
 char ash[] = "ash";
 char sudosh[] = "/usr/bin/sudo.sh";
 //if (argc==2) execle(binash,ash,sudosh,argv[1],(char*) NULL,envp2);
 if (argc==3) execle(binash,ash,sudosh,argv[1],argv[2],(char*) NULL,envp2);
 if (argc==4) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],(char*) NULL,envp2);
 if (argc==5) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],(char*) NULL,envp2);
 if (argc==6) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],(char*) NULL,envp2);
 if (argc==7) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],(char*) NULL,envp2);
 if (argc==8) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],(char*) NULL,envp2);
 //20250330 handle more params...
 if (argc==9) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],argv[8],(char*) NULL,envp2);
 if (argc==10) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],argv[8],argv[9],(char*) NULL,envp2);
 if (argc==11) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],argv[8],argv[9],argv[10],(char*) NULL,envp2);
 if (argc==12) execle(binash,ash,sudosh,argv[1],argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],argv[8],argv[9],argv[10],argv[11],(char*) NULL,envp2);
}
